/*
 * @Author: 付刚
 * @Date: 2021-06-03 18:19:56
 * @LastEditors: 付刚
 * @LastEditTime: 2021-06-03 21:11:31
 * @FilePath: \MuduAPP\.eslintrc.js
 */
module.exports = {
  root: true,
  env: {
    node: true
  },
  extends: ['plugin:vue/essential', 'eslint:recommended'],
  rules: {
    'no-console': process.env.NODE_ENV === 'production' ? 'error' : 'off',
    'no-debugger': process.env.NODE_ENV === 'production' ? 'error' : 'off',
    //允许定义变量不使用
    'no-unused-vars': 'off',
    //强制使用单引号
    quotes: ['error', 'single'],
    //强制不使用分号结尾
    semi: ['error', 'never']
  },
  parserOptions: {
    parser: 'babel-eslint'
  }
}
