let routes = [
  {
    path: '/',
    component: () => import('@/views/vxEwm/garden/index.vue'),
    redirect: '/park',
    children: [
      {
        path: '/park',
        name: '工业园',
        component: () => import('@/views/vxEwm/garden/park/index.vue'),
      },
    ],
  },
  {
    path: '/enterpriseData',
    name: '企业信息',
    component: () => import('@/views/vxEwm/enterprise/index.vue'),
    redirect: '/enterpriseData/info',
    children: [
      {
        path: '/enterpriseData/info',
        name: '企业详情',
        component: () => import('@/views/vxEwm/enterprise/info.vue'),
      },
      {
        path: '/enterpriseData/check/info',
        name: '巡检详情',
        component: () =>
          import('@/views/vxEwm/enterprise/components/firmInfo.vue'),
      },
    ],
  },
  {
    path: '/build',
    name: '楼栋企业',
    component: () => import('@/views/vxEwm/build/index.vue'),
    children: [
      {
        path: '/build',
        name: '楼栋企业',
        component: () => import('@/views/vxEwm/build/build/index.vue'),
      },
    ],
  },
  {
    path: '/enterpriseData2',
    name: '企业信息',
    component: () => import('@/views/vxEwm/enterprise/index.vue'),
    redirect: '/enterpriseData2/info',
    children: [
      {
        path: '/enterpriseData2/info',
        name: '企业详情2',
        component: () => import('@/views/vxEwm/enterprise/info.vue'),
      },
      {
        path: '/enterpriseData2/check/info',
        name: '巡检详情',
        component: () =>
          import('@/views/vxEwm/enterprise/components/firmInfo.vue'),
      },
    ],
  },
]

// {
//   path: '/enterpriseData/check/info/:id',
//   name: '巡检详情',
//   component: () =>
//     import('@/views/vxEwm/enterprise/components/check/info.vue'),
// },
export default routes
